#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#define MAXR 6

int MMap[MAXR][MAXR];
int MMax[MAXR];
int MWas[MAXR];
int CMap[MAXR][MAXR];
int CMax[MAXR];
int CWas[MAXR];


int CHome,MHome,RoomsN;

int MouseCycle,CatMet;

char *yesno="NY";

void GetCat(int RN)
{
  int i;

  if (CWas[RN] == 1) return;
  CWas[RN]=1;

  for (i=0;i<CMax[RN];i++)
	 GetCat(CMap[RN][i]);

}

void GetMouse(int RN,int Deep)
{
  int i;

  if (CWas[RN] == 1) {
	 CatMet=1;
	 return;
  }

  if ( (RN==MHome) && (Deep > 2) ) {
	 MouseCycle=1;
	 return;
  }

  if (MWas[RN] == 1) return;
  MWas[RN]=1;

  for (i=0;i<MMax[RN];i++) {
	 GetMouse(MMap[RN][i],Deep+1);
  }

}


void RunMain()
{
  int From,To;

  scanf("%d %d %d",&RoomsN,&CHome,&MHome);

  memset(CMax,0,sizeof(CMax));
  while (1) {
	 scanf("%d %d",&From,&To);
	 if (From == -1) break;

	 CMap[From][CMax[From]++] = To;
  }

  memset(&MMax[0],0,sizeof(MMax));
  while (!feof(stdin)) {
	 scanf("%d %d",&From,&To);
	 if (From == -1) break;

	 MMap[From][MMax[From]++] = To;

  }

  memset(&CWas[0],0,sizeof(CWas));
  GetCat(CHome);

  CatMet=0;
  MouseCycle=0;
  GetMouse(MHome,0);

  printf("%c %c\n",yesno[CatMet],yesno[MouseCycle]);

}

int main(int argc,char *argv[])
{
  int i,CasesN,N1,N2;

  if (argc > 1)
	 if (freopen(argv[1], "r", stdin) == NULL)
	  fprintf(stderr, "error redirecting stdin\n");

  if (argc > 2)
	 if (freopen(argv[2], "w", stdout) == NULL)
	  fprintf(stderr, "error redirecting stdout\n");

  RunMain();

  fclose(stdin);
  fclose(stdout);

  return 0;
}
